import { FrontendSchemaService, StoreRegistry } from "@smallstack/common-components";
import { FrontendTypeRegistry } from "@smallstack/type-components";
import { SearchQuery, SmallstackType, SmallstackTypeSchema } from "@smallstack/typesystem";
import { BaseWidgetComponent } from "@smallstack/widget-core";
import { BehaviorSubject } from "rxjs";
import * as i0 from "@angular/core";
export declare enum FilterBarSockets {
    SEARCH_QUERY = "searchQuery"
}
export declare class FilterBarWidgetComponent extends BaseWidgetComponent {
    private typeRegistry;
    private storeRegistry;
    protected searchQuery: SearchQuery;
    protected isSearching$: BehaviorSubject<boolean>;
    protected isLoading$: BehaviorSubject<boolean>;
    protected filterOnType$: BehaviorSubject<string>;
    protected type: SmallstackType;
    protected searchSchema: SmallstackTypeSchema;
    protected filterValue: any;
    constructor(typeRegistry: FrontendTypeRegistry, schemaService: FrontendSchemaService, storeRegistry: StoreRegistry);
    protected reset(): void;
    protected filter(): () => Promise<void>;
    static ɵfac: i0.ɵɵFactoryDeclaration<FilterBarWidgetComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<FilterBarWidgetComponent, "smallstack-filter-bar-widget", never, {}, {}, never, never, true, never>;
}
