import { SchedulingRuleV2Dto } from "@smallstack/axios-api-client";
import { DataStore } from "@smallstack/common-components";
import { SessionStorageStore } from "@smallstack/store";
import { FrontendTypeRegistry } from "@smallstack/type-components";
import { BaseWidgetComponent } from "@smallstack/widget-core";
import { BehaviorSubject, Observable } from "rxjs";
import * as i0 from "@angular/core";
export interface TaskInfo {
    title: string;
    userIds: string[];
    startPercentage: number;
    endPercentage: number;
    startedYesterday: boolean;
    continuesTomorrow: boolean;
}
export interface DayInfo {
    dayName: string;
    dayStart: number;
    tasks: TaskInfo[];
}
export interface WeekInfo {
    weekDescription: string;
    days: DayInfo[];
    percentage: number;
    totalDuration: number;
    workingHours: number;
}
export declare const WORKING_DAY_STARTING_HOUR = 0;
export declare const WORKING_DAY_ENDING_HOUR = 24;
export declare const WORKING_DAY_DURATION: number;
interface Task {
    scheduling: SchedulingRuleV2Dto;
    start: number;
    durationInHours: number;
    title: string;
    userIds: string[];
}
export declare class ResourcePlanningUserStatsComponent extends BaseWidgetComponent {
    private dataStore;
    private frontendTypeRegistry;
    private tasksStore;
    protected zoom$: BehaviorSubject<number>;
    protected user$: Observable<any>;
    protected allTasks$: Observable<Task[]>;
    protected weeks$: Observable<WeekInfo[]>;
    protected userStatsShownStore$$: SessionStorageStore<string>;
    constructor(dataStore: DataStore, frontendTypeRegistry: FrontendTypeRegistry);
    protected showTimelineFor(userId: string, weekDescription: string): void;
    protected zoomIn(): void;
    protected zoomOut(): void;
    protected showTaskDetails(task: TaskInfo): void;
    protected createNewTask(day: DayInfo): Promise<void>;
    static ɵfac: i0.ɵɵFactoryDeclaration<ResourcePlanningUserStatsComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ResourcePlanningUserStatsComponent, "smallstack-resource-planning-user-stats", never, {}, {}, never, never, true, never>;
}
export {};
